<?php

//Blog

if(!function_exists('kudos_qodef_map_blog')) {
    function kudos_qodef_map_blog() {

        $qode_blog_categories = array();
        $categories = get_categories();
        foreach ($categories as $category) {
            $qode_blog_categories[$category->term_id] = $category->name;
        }

        $blog_meta_box = kudos_qodef_create_meta_box(
            array(
                'scope' => array('page'),
                'title' => esc_html__('Blog', 'kudos'),
                'name' => 'blog_meta'
            )
        );

        kudos_qodef_create_meta_box_field(
            array(
                'name' => 'qodef_blog_category_meta',
                'type' => 'selectblank',
                'label' => esc_html__('Blog Category', 'kudos'),
                'description' => 'Choose category of posts to display (leave empty to display all categories)',
                'parent' => $blog_meta_box,
                'options' => $qode_blog_categories
            )
        );

        kudos_qodef_create_meta_box_field(
            array(
                'name' => 'qodef_show_posts_per_page_meta',
                'type' => 'text',
                'label' => esc_html__('Number of Posts', 'kudos'),
                'description' => 'Enter the number of posts to display',
                'parent' => $blog_meta_box,
                'options' => $qode_blog_categories,
                'args' => array("col_width" => 3)
            )
        );

    }

    add_action('kudos_qodef_meta_boxes_map', 'kudos_qodef_map_blog');

}
