<?php

if(!function_exists('kudos_qodef_map_portfolio_settings')) {
    function kudos_qodef_map_portfolio_settings() {
        $meta_box = kudos_qodef_create_meta_box(array(
            'scope' => 'portfolio-item',
            'title' => esc_html__('Portfolio Settings', 'kudos'),
            'name'  => 'portfolio_settings_meta_box'
        ));

        kudos_qodef_create_meta_box_field(array(
            'name'        => 'qodef_portfolio_single_template_meta',
            'type'        => 'select',
            'label'       => esc_html__('Portfolio Type', 'kudos'),
            'description' => esc_html__('Choose a default type for Single Project pages', 'kudos'),
            'parent'      => $meta_box,
            'options'     => array(
                ''                  => esc_html__('Default', 'kudos'),
                'small-images'      => esc_html__('Portfolio small images', 'kudos'),
                'small-slider'      => esc_html__('Portfolio small slider', 'kudos'),
                'big-images'        => esc_html__('Portfolio big images', 'kudos'),
                'big-slider'        => esc_html__('Portfolio big slider', 'kudos'),
                'gallery' => esc_html__('Portfolio gallery', 'kudos'),
                'masonry-gallery-left' => esc_html__('Portfolio masonry gallery left', 'kudos'),
                'masonry-gallery-bottom' => esc_html__('Portfolio masonry gallery bottom', 'kudos'),
                'pinterest' => esc_html__('Portfolio pinterest', 'kudos'),
                'pinterest-right' => esc_html__('Portfolio pinterest right', 'kudos'),
                'pinterest-left' => esc_html__('Portfolio pinterest left', 'kudos'),
                'full-width-images' => esc_html__('Portfolio full width images', 'kudos'),
                'fixed-left' => esc_html__('Portfolio fixed left', 'kudos'),
                'custom'            => esc_html__('Portfolio custom', 'kudos'),
                'full-width-custom' => esc_html__('Portfolio full width custom', 'kudos'),
                'full-width-custom-info-bottom' => esc_html__('Portfolio full width custom, info bottom', 'kudos')
            )
        ));

        $all_pages = array();
        $pages     = get_pages();
        foreach($pages as $page) {
            $all_pages[$page->ID] = $page->post_title;
        }

        kudos_qodef_create_meta_box_field(array(
            'name'        => 'portfolio_single_back_to_link',
            'type'        => 'select',
            'label'       => esc_html__('"Back To" Link', 'kudos'),
            'description' => esc_html__('Choose "Back To" page to link from portfolio Single Project page', 'kudos'),
            'parent'      => $meta_box,
            'options'     => $all_pages
        ));

        kudos_qodef_create_meta_box_field(array(
            'name'        => 'portfolio_external_link',
            'type'        => 'text',
            'label'       => esc_html__('Portfolio External Link', 'kudos'),
            'description' => esc_html__('Enter URL to link from Portfolio List page', 'kudos'),
            'parent'      => $meta_box,
            'args'        => array(
                'col_width' => 3
            )
        ));

        kudos_qodef_create_meta_box_field(array(
            'name'        => 'portfolio_masonry_dimenisions',
            'type'        => 'select',
            'label'       => esc_html__('Dimensions for Masonry', 'kudos'),
            'description' => esc_html__('Choose image layout when it appears in Masonry type portfolio lists', 'kudos'),
            'parent'      => $meta_box,
            'options'     => array(
                'default'            => esc_html__('Default', 'kudos'),
                'large_width'        => esc_html__('Large width', 'kudos'),
                'large_height'       => esc_html__('Large height', 'kudos'),
                'large_width_height' => esc_html__('Large width/height', 'kudos')
            )
        ));
    }

    add_action('kudos_qodef_meta_boxes_map', 'kudos_qodef_map_portfolio_settings');
}