<?php

if ( ! function_exists('kudos_qodef_general_options_map') ) {
    /**
     * General options page
     */
    function kudos_qodef_general_options_map() {

        kudos_qodef_add_admin_page(
            array(
                'slug'  => '',
                'title' => esc_html__('General', 'kudos'),
                'icon'  => 'fa fa-institution'
            )
        );

        $panel_design_style = kudos_qodef_add_admin_panel(
            array(
                'page'  => '',
                'name'  => 'panel_design_style',
                'title' => esc_html__('Design Style', 'kudos')
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'google_fonts',
                'type'          => 'font',
                'default_value' => '-1',
                'label'         => esc_html__('Google Font Family', 'kudos'),
                'description'   => esc_html__('Choose a default Google font for your site', 'kudos'),
                'parent' => $panel_design_style
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'additional_google_fonts',
                'type'          => 'yesno',
                'default_value' => 'no',
                'label'         => esc_html__('Additional Google Fonts', 'kudos'),
                'description'   => '',
                'parent'        => $panel_design_style,
                'args'          => array(
                    "dependence" => true,
                    "dependence_hide_on_yes" => "",
                    "dependence_show_on_yes" => "#qodef_additional_google_fonts_container"
                )
            )
        );

        $additional_google_fonts_container = kudos_qodef_add_admin_container(
            array(
                'parent'            => $panel_design_style,
                'name'              => 'additional_google_fonts_container',
                'hidden_property'   => 'additional_google_fonts',
                'hidden_value'      => 'no'
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'additional_google_font1',
                'type'          => 'font',
                'default_value' => '-1',
                'label'         => esc_html__('Font Family', 'kudos'),
                'description'   => esc_html__('Choose additional Google font for your site', 'kudos'),
                'parent'        => $additional_google_fonts_container
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'additional_google_font2',
                'type'          => 'font',
                'default_value' => '-1',
                'label'         => esc_html__('Font Family', 'kudos'),
                'description'   => esc_html__('Choose additional Google font for your site', 'kudos'),
                'parent'        => $additional_google_fonts_container
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'additional_google_font3',
                'type'          => 'font',
                'default_value' => '-1',
                'label'         => esc_html__('Font Family', 'kudos'),
                'description'   => esc_html__('Choose additional Google font for your site', 'kudos'),
                'parent'        => $additional_google_fonts_container
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'additional_google_font4',
                'type'          => 'font',
                'default_value' => '-1',
                'label'         => esc_html__('Font Family', 'kudos'),
                'description'   => esc_html__('Choose additional Google font for your site', 'kudos'),
                'parent'        => $additional_google_fonts_container
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'additional_google_font5',
                'type'          => 'font',
                'default_value' => '-1',
                'label'         => esc_html__('Font Family', 'kudos'),
                'description'   => esc_html__('Choose additional Google font for your site', 'kudos'),
                'parent'        => $additional_google_fonts_container
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name' => 'google_font_weight',
                'type' => 'checkboxgroup',
                'default_value' => '',
                'label' => esc_html__('Google Fonts Style & Weight', 'kudos'),
                'description' => esc_html__('Choose a default Google font weights for your site. Impact on page load time', 'kudos'),
                'parent' => $panel_design_style,
                'options' => array(
                    '100'       => esc_html__('100 Thin', 'kudos'),
                    '100italic' => esc_html__('100 Thin Italic', 'kudos'),
                    '200'       => esc_html__('200 Extra-Light', 'kudos'),
                    '200italic' => esc_html__('200 Extra-Light Italic', 'kudos'),
                    '300'       => esc_html__('300 Light', 'kudos'),
                    '300italic' => esc_html__('300 Light Italic', 'kudos'),
                    '400'       => esc_html__('400 Regular', 'kudos'),
                    '400italic' => esc_html__('400 Regular Italic', 'kudos'),
                    '500'       => esc_html__('500 Medium', 'kudos'),
                    '500italic' => esc_html__('500 Medium Italic', 'kudos'),
                    '600'       => esc_html__('600 Semi-Bold', 'kudos'),
                    '600italic' => esc_html__('600 Semi-Bold Italic', 'kudos'),
                    '700'       => esc_html__('700 Bold', 'kudos'),
                    '700italic' => esc_html__('700 Bold Italic', 'kudos'),
                    '800'       => esc_html__('800 Extra-Bold', 'kudos'),
                    '800italic' => esc_html__('800 Extra-Bold Italic', 'kudos'),
                    '900'       => esc_html__('900 Ultra-Bold', 'kudos'),
                    '900italic' => esc_html__('900 Ultra-Bold Italic', 'kudos')
                ),
                'args' => array(
                    'enable_empty_checkbox' => true,
                    'inline_checkbox_class' => true
                )
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name' => 'google_font_subset',
                'type' => 'checkboxgroup',
                'default_value' => '',
                'label' => esc_html__('Google Fonts Subset', 'kudos'),
                'description' => esc_html__('Choose a default Google font subsets for your site', 'kudos'),
                'parent' => $panel_design_style,
                'options' => array(
                    'latin' => esc_html__('Latin', 'kudos'),
                    'latin-ext' => esc_html__('Latin Extended', 'kudos'),
                    'cyrillic' => esc_html__('Cyrillic', 'kudos'),
                    'cyrillic-ext' => esc_html__('Cyrillic Extended', 'kudos'),
                    'greek' => esc_html__('Greek', 'kudos'),
                    'greek-ext' => esc_html__('Greek Extended', 'kudos'),
                    'vietnamese' => esc_html__('Vietnamese', 'kudos')
                ),
                'args' => array(
                    'enable_empty_checkbox' => true,
                    'inline_checkbox_class' => true
                )
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'first_color',
                'type'          => 'color',
                'label'         => esc_html__('First Main Color', 'kudos'),
                'description'   => esc_html__('Choose the most dominant theme color. Default color is #ff1d4d', 'kudos'),
                'parent'        => $panel_design_style
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'page_background_color',
                'type'          => 'color',
                'label'         => esc_html__('Page Background Color', 'kudos'),
                'description'   => esc_html__('Choose the background color for page content. Default color is #ffffff', 'kudos'),
                'parent'        => $panel_design_style
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'selection_color',
                'type'          => 'color',
                'label'         => esc_html__('Text Selection Color', 'kudos'),
                'description'   => esc_html__('Choose the color users see when selecting text', 'kudos'),
                'parent'        => $panel_design_style
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'boxed',
                'type'          => 'yesno',
                'default_value' => 'no',
                'label'         => esc_html__('Boxed Layout', 'kudos'),
                'description'   => '',
                'parent'        => $panel_design_style,
                'args'          => array(
                    "dependence" => true,
                    "dependence_hide_on_yes" => "",
                    "dependence_show_on_yes" => "#qodef_boxed_container"
                )
            )
        );

        $boxed_container = kudos_qodef_add_admin_container(
            array(
                'parent'            => $panel_design_style,
                'name'              => 'boxed_container',
                'hidden_property'   => 'boxed',
                'hidden_value'      => 'no'
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'page_background_color_in_box',
                'type'          => 'color',
                'label'         => esc_html__('Page Background Color', 'kudos'),
                'description'   => esc_html__('Choose the page background color outside box.', 'kudos'),
                'parent'        => $boxed_container
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'boxed_background_image',
                'type'          => 'image',
                'label'         => esc_html__('Background Image', 'kudos'),
                'description'   => esc_html__('Choose an image to be displayed in background', 'kudos'),
                'parent'        => $boxed_container
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'boxed_pattern_background_image',
                'type'          => 'image',
                'label'         => esc_html__('Background Pattern', 'kudos'),
                'description'   => esc_html__('Choose an image to be used as background pattern', 'kudos'),
                'parent'        => $boxed_container
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'boxed_background_image_attachment',
                'type'          => 'select',
                'default_value' => 'fixed',
                'label'         => esc_html__('Background Image Attachment', 'kudos'),
                'description'   => esc_html__('Choose background image attachment', 'kudos'),
                'parent'        => $boxed_container,
                'options'       => array(
                    'fixed'     => 'Fixed',
                    'scroll'    => 'Scroll'
                )
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'initial_content_width',
                'type'          => 'select',
                'default_value' => '',
                'label'         => esc_html__('Initial Width of Content', 'kudos'),
                'description'   => esc_html__('Choose the initial width of content which is in grid (Applies to pages set to Default Template and rows set to In Grid)', 'kudos'),
                'parent'        => $panel_design_style,
                'options'       => array(
                    ''          => esc_html__('1100px - default', 'kudos'),
                    'grid-1300' => esc_html__('1300px', 'kudos'),
                    'grid-1200' => esc_html__('1200px', 'kudos'),
                    'grid-1000' => esc_html__('1000px', 'kudos'),
                    'grid-800' => esc_html__('800px', 'kudos')
                )
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'preload_pattern_image',
                'type'          => 'image',
                'label'         => esc_html__('Preload Pattern Image', 'kudos'),
                'description'   => esc_html__('Choose preload pattern image to be displayed until images are loaded ', 'kudos'),
                'parent'        => $panel_design_style
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name' => 'element_appear_amount',
                'type' => 'text',
                'label' => esc_html__('Element Appearance', 'kudos'),
                'description' => esc_html__('For animated elements, set distance (related to browser bottom) to start the animation', 'kudos'),
                'parent' => $panel_design_style,
                'args' => array(
                    'col_width' => 2,
                    'suffix' => 'px'
                )
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'passepartout',
                'type'          => 'yesno',
                'default_value' => 'no',
                'label'         => esc_html__('Enable Passepartout', 'kudos'),
                'description'   => esc_html__('Enabling this option will show passepartout around wrapper', 'kudos'),
                'parent'        => $panel_design_style
            )
        );



        $panel_settings = kudos_qodef_add_admin_panel(
            array(
                'page'  => '',
                'name'  => 'panel_settings',
                'title' => esc_html__('Settings', 'kudos')
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'smooth_scroll',
                'type'          => 'yesno',
                'default_value' => 'no',
                'label'         => esc_html__('Smooth Scroll', 'kudos'),
                'description'   => esc_html__('Enabling this option will perform a smooth scrolling effect on every page (except on Mac and touch devices)', 'kudos'),
                'parent'        => $panel_settings
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'smooth_page_transitions',
                'type'          => 'yesno',
                'default_value' => 'no',
                'label'         => esc_html__('Smooth Page Transitions', 'kudos'),
                'description'   => esc_html__('Enabling this option will perform a smooth transition between pages when clicking on links.', 'kudos'),
                'parent'        => $panel_settings,
                'args'          => array(
                    "dependence" => true,
                    "dependence_hide_on_yes" => "",
                    "dependence_show_on_yes" => "#qodef_page_transitions_container"
                )
            )
        );

        $page_transitions_container = kudos_qodef_add_admin_container(
            array(
                'parent'            => $panel_settings,
                'name'              => 'page_transitions_container',
                'hidden_property'   => 'smooth_page_transitions',
                'hidden_value'      => 'no'
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'smooth_pt_bgnd_color',
                'type'          => 'color',
                'label'         => esc_html__('Page Loader Background Color', 'kudos'),
                //'description'   => 'Enabling this option will perform a smooth transition between pages when clicking on links.',
                'parent'        => $page_transitions_container
            )
        );

        $group_pt_spinner_animation = kudos_qodef_add_admin_group(array(
            'name'          => 'group_pt_spinner_animation',
            'title'         => esc_html__('Loader Style', 'kudos'),
            'description'   => esc_html__('Define styles for loader spinner animation', 'kudos'),
            'parent'        => $page_transitions_container
        ));

        $row_pt_spinner_animation = kudos_qodef_add_admin_row(array(
            'name'      => 'row_pt_spinner_animation',
            'parent'    => $group_pt_spinner_animation
        ));

        kudos_qodef_add_admin_field(array(
            'type'          => 'selectsimple',
            'name'          => 'smooth_pt_spinner_type',
            'default_value' => '',
            'label'         => esc_html__('Spinner Type', 'kudos'),
            'parent'        => $row_pt_spinner_animation,
            'options'       => array(
                'pulse' => esc_html__('Pulse', 'kudos'),
                'double_pulse' => esc_html__('Double Pulse', 'kudos'),
                'cube' => esc_html__('Cube', 'kudos'),
                'rotating_cubes' => esc_html__('Rotating Cubes', 'kudos'),
                'stripes' => esc_html__('Stripes', 'kudos'),
                'wave' => esc_html__('Wave', 'kudos'),
                'two_rotating_circles' => esc_html__('2 Rotating Circles', 'kudos'),
                'five_rotating_circles' => esc_html__('5 Rotating Circles', 'kudos'),
                'atom' => esc_html__('Atom', 'kudos'),
                'clock' => esc_html__('Clock', 'kudos'),
                'mitosis' => esc_html__('Mitosis', 'kudos'),
                'lines' => esc_html__('Lines', 'kudos'),
                'fussion' => esc_html__('Fussion', 'kudos'),
                'wave_circles' => esc_html__('Wave Circles', 'kudos'),
                'pulse_circles' => esc_html__('Pulse Circles', 'kudos')
            )
        ));

        kudos_qodef_add_admin_field(array(
            'type'          => 'colorsimple',
            'name'          => 'smooth_pt_spinner_color',
            'default_value' => '',
            'label'         => esc_html__('Spinner Color', 'kudos'),
            'parent'        => $row_pt_spinner_animation
        ));

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'show_back_button',
                'type'          => 'yesno',
                'default_value' => 'yes',
                'label'         => esc_html__('Show "Back To Top Button"', 'kudos'),
                'description'   => esc_html__('Enabling this option will display a Back to Top button on every page', 'kudos'),
                'parent'        => $panel_settings
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'responsiveness',
                'type'          => 'yesno',
                'default_value' => 'yes',
                'label'         => esc_html__('Responsiveness', 'kudos'),
                'description'   => esc_html__('Enabling this option will make all pages responsive', 'kudos'),
                'parent'        => $panel_settings
            )
        );

        $panel_custom_code = kudos_qodef_add_admin_panel(
            array(
                'page'  => '',
                'name'  => 'panel_custom_code',
                'title' => esc_html__('Custom Code', 'kudos')
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'custom_css',
                'type'          => 'textarea',
                'label'         => esc_html__('Custom CSS', 'kudos'),
                'description'   => esc_html__('Enter your custom CSS here', 'kudos'),
                'parent'        => $panel_custom_code
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'          => 'custom_js',
                'type'          => 'textarea',
                'label'         => esc_html__('Custom JS', 'kudos'),
                'description'   => esc_html__('Enter your custom Javascript here', 'kudos'),
                'parent'        => $panel_custom_code
            )
        );

        $panel_google_api = kudos_qodef_add_admin_panel(
            array(
                'page'  => '',
                'name'  => 'panel_google_api',
                'title' => esc_html__('Google API', 'kudos')
            )
        );

        kudos_qodef_add_admin_field(
            array(
                'name'        => 'google_maps_api_key',
                'type'        => 'text',
                'label'       => esc_html__('Google Maps Api Key', 'kudos'),
                'description' => esc_html__('Insert your Google Maps API key here. For instructions on how to create a Google Maps API key, please refer to our documentation.', 'kudos'),
                'parent'      => $panel_google_api
            )
        );

    }

    add_action( 'kudos_qodef_options_map', 'kudos_qodef_general_options_map', 1);

}