<?php

if ( ! function_exists('kudos_qodef_page_options_map') ) {

    function kudos_qodef_page_options_map() {

        kudos_qodef_add_admin_page(
            array(
                'slug'  => '_page_page',
                'title' => esc_html__('Page', 'kudos'),
                'icon'  => 'fa fa-institution'
            )
        );

        $custom_sidebars = kudos_qodef_get_custom_sidebars();

        $panel_sidebar = kudos_qodef_add_admin_panel(
            array(
                'page'  => '_page_page',
                'name'  => 'panel_sidebar',
                'title' => esc_html__('Design Style', 'kudos')
            )
        );

        kudos_qodef_add_admin_field(array(
            'name'        => 'page_sidebar_layout',
            'type'        => 'select',
            'label'       => esc_html__('Sidebar Layout', 'kudos'),
            'description' => esc_html__('Choose a sidebar layout for pages', 'kudos'),
            'default_value' => 'default',
            'parent'      => $panel_sidebar,
            'options'     => array(
                'default'			=> esc_html__('No Sidebar', 'kudos'),
                'sidebar-33-right'	=> esc_html__('Sidebar 1/3 Right', 'kudos'),
                'sidebar-25-right' 	=> esc_html__('Sidebar 1/4 Right', 'kudos'),
                'sidebar-33-left' 	=> esc_html__('Sidebar 1/3 Left', 'kudos'),
                'sidebar-25-left' 	=> esc_html__('Sidebar 1/4 Left', 'kudos')
            )
        ));


        if(count($custom_sidebars) > 0) {
            kudos_qodef_add_admin_field(array(
                'name' => 'page_custom_sidebar',
                'type' => 'selectblank',
                'label' => esc_html__('Sidebar to Display', 'kudos'),
                'description' => esc_html__('Choose a sidebar to display on pages. Default sidebar is "Sidebar"', 'kudos'),
                'parent' => $panel_sidebar,
                'options' => $custom_sidebars
            ));
        }

        kudos_qodef_add_admin_field(array(
            'name'        => 'page_show_comments',
            'type'        => 'yesno',
            'label'       => esc_html__('Show Comments', 'kudos'),
            'description' => esc_html__('Enabling this option will show comments on your page', 'kudos'),
            'default_value' => 'yes',
            'parent'      => $panel_sidebar
        ));

    }

    add_action( 'kudos_qodef_options_map', 'kudos_qodef_page_options_map',9);

}