<?php

if ( ! function_exists('kudos_qodef_portfolio_options_map') ) {

	function kudos_qodef_portfolio_options_map() {

		kudos_qodef_add_admin_page(array(
			'slug'  => '_portfolio',
			'title' => esc_html__('Portfolio', 'kudos'),
			'icon'  => 'fa fa-camera-retro'
		));

		$panel = kudos_qodef_add_admin_panel(array(
			'title' => esc_html__('Portfolio Single', 'kudos'),
			'name'  => 'panel_portfolio_single',
			'page'  => '_portfolio'
		));

		kudos_qodef_add_admin_field(array(
			'name'        => 'portfolio_single_template',
			'type'        => 'select',
			'label'       => esc_html__('Portfolio Type', 'kudos'),
			'default_value'	=> 'small-images',
			'description' => esc_html__('Choose a default type for Single Project pages', 'kudos'),
			'parent'      => $panel,
			'options'     => array(
				'small-images' => esc_html__('Portfolio small images', 'kudos'),
				'small-slider' => esc_html__('Portfolio small slider', 'kudos'),
				'big-images' => esc_html__('Portfolio big images', 'kudos'),
				'big-slider' => esc_html__('Portfolio big slider', 'kudos'),
				'gallery' => esc_html__('Portfolio gallery', 'kudos'),
				'masonry-gallery-left' => esc_html__('Portfolio masonry gallery left', 'kudos'),
				'masonry-gallery-bottom' => esc_html__('Portfolio masonry gallery bottom', 'kudos'),
				'pinterest' => esc_html__('Portfolio pinterest', 'kudos'),
				'pinterest-right' => esc_html__('Portfolio pinterest right', 'kudos'),
				'pinterest-left' => esc_html__('Portfolio pinterest left', 'kudos'),
				'full-width-images' => esc_html__('Portfolio fullwidth images', 'kudos'),
				'fixed-left' => esc_html__('Portfolio fixed left', 'kudos'),
				'custom' => esc_html__('Portfolio custom', 'kudos'),
				'full-width-custom' => esc_html__('Portfolio full width custom', 'kudos'),
				'full-width-custom-info-bottom' => esc_html__('Portfolio full width custom, info bottom', 'kudos')

			)
		));

		kudos_qodef_add_admin_field(array(
			'name'          => 'portfolio_single_lightbox_images',
			'type'          => 'yesno',
			'label'         => esc_html__('Lightbox for Images', 'kudos'),
			'description'   => esc_html__('Enabling this option will turn on lightbox functionality for projects with images.', 'kudos'),
			'parent'        => $panel,
			'default_value' => 'yes'
		));

		kudos_qodef_add_admin_field(array(
			'name'          => 'portfolio_single_lightbox_videos',
			'type'          => 'yesno',
			'label'         => esc_html__('Lightbox for Videos', 'kudos'),
			'description'   => esc_html__('Enabling this option will turn on lightbox functionality for YouTube/Vimeo projects.', 'kudos'),
			'parent'        => $panel,
			'default_value' => 'no'
		));

		kudos_qodef_add_admin_field(array(
			'name'          => 'portfolio_single_hide_categories',
			'type'          => 'yesno',
			'label'         => esc_html__('Hide Categories', 'kudos'),
			'description'   => esc_html__('Enabling this option will disable category meta description on Single Projects.', 'kudos'),
			'parent'        => $panel,
			'default_value' => 'no'
		));

		kudos_qodef_add_admin_field(array(
			'name'          => 'portfolio_single_hide_date',
			'type'          => 'yesno',
			'label'         => esc_html__('Hide Date', 'kudos'),
			'description'   => esc_html__('Enabling this option will disable date meta on Single Projects.', 'kudos'),
			'parent'        => $panel,
			'default_value' => 'no'
		));

		kudos_qodef_add_admin_field(array(
			'name'          => 'portfolio_single_comments',
			'type'          => 'yesno',
			'label'         => esc_html__('Show Comments', 'kudos'),
			'description'   => esc_html__('Enabling this option will show comments on your page.', 'kudos'),
			'parent'        => $panel,
			'default_value' => 'no'
		));

		kudos_qodef_add_admin_field(array(
			'name'          => 'portfolio_single_sticky_sidebar',
			'type'          => 'yesno',
			'label'         => esc_html__('Sticky Side Text', 'kudos'),
			'description'   => esc_html__('Enabling this option will make side text sticky on Single Project pages', 'kudos'),
			'parent'        => $panel,
			'default_value' => 'yes'
		));

		kudos_qodef_add_admin_field(array(
			'name'          => 'portfolio_single_hide_pagination',
			'type'          => 'yesno',
			'label'         => esc_html__('Hide Pagination', 'kudos'),
			'description'   => esc_html__('Enabling this option will turn off portfolio pagination functionality.', 'kudos'),
			'parent'        => $panel,
			'default_value' => 'no',
			'args' => array(
				'dependence' => true,
				'dependence_hide_on_yes' => '#qodef_navigate_same_category_container'
			)
		));

		$container_navigate_category = kudos_qodef_add_admin_container(array(
			'name'            => 'navigate_same_category_container',
			'parent'          => $panel,
			'hidden_property' => 'portfolio_single_hide_pagination',
			'hidden_value'    => 'yes'
		));

		kudos_qodef_add_admin_field(array(
			'name'            => 'portfolio_single_nav_same_category',
			'type'            => 'yesno',
			'label'           => esc_html__('Enable Pagination Through Same Category', 'kudos'),
			'description'     => esc_html__('Enabling this option will make portfolio pagination sort through current category.', 'kudos'),
			'parent'          => $container_navigate_category,
			'default_value'   => 'no'
		));

		kudos_qodef_add_admin_field(array(
			'name'        => 'portfolio_single_numb_columns',
			'type'        => 'select',
			'label'       => esc_html__('Number of Columns', 'kudos'),
			'default_value' => 'three-columns',
			'description' => esc_html__('Enter the number of columns for Portfolio Gallery type', 'kudos'),
			'parent'      => $panel,
			'options'     => array(
				'two-columns' => esc_html__('2 columns', 'kudos'),
				'three-columns' => esc_html__('3 columns', 'kudos'),
				'four-columns' => esc_html__('4 columns', 'kudos')
			)
		));

		kudos_qodef_add_admin_field(array(
			'name'        => 'portfolio_single_slug',
			'type'        => 'text',
			'label'       => esc_html__('Portfolio Single Slug', 'kudos'),
			'description' => esc_html__('Enter if you wish to use a different Single Project slug (Note: After entering slug, navigate to Settings -> Permalinks and click "Save" in order for changes to take effect)', 'kudos'),
			'parent'      => $panel,
			'args'        => array(
				'col_width' => 3
			)
		));

	}

	add_action( 'kudos_qodef_options_map', 'kudos_qodef_portfolio_options_map',14);

}