<?php
if (!function_exists('kudos_qodef_register_side_area_sidebar')) {
	/**
	 * Register side area sidebar
	 */
	function kudos_qodef_register_side_area_sidebar() {

		register_sidebar(array(
			'name' => esc_html__('Side Area', 'kudos'),
			'id' => 'sidearea', //TODO Change name of sidebar
			'description' => esc_html__('Side Area', 'kudos'),
			'before_widget' => '<div id="%1$s" class="widget qodef-sidearea %2$s">',
			'after_widget' => '</div>',
			'before_title' => '<h4 class="qodef-sidearea-widget-title">',
			'after_title' => '</h4>'
		));

	}

	add_action('widgets_init', 'kudos_qodef_register_side_area_sidebar');

}

if(!function_exists('kudos_qodef_side_menu_body_class')) {
    /**
     * Function that adds body classes for different side menu styles
     *
     * @param $classes array original array of body classes
     *
     * @return array modified array of classes
     */
    function kudos_qodef_side_menu_body_class($classes) {

		if (is_active_widget( false, false, 'qodef_side_area_opener' )) {

			if (kudos_qodef_options()->getOptionValue('side_area_type')) {

				$classes[] = 'qodef-' . kudos_qodef_options()->getOptionValue('side_area_type');

				if (kudos_qodef_options()->getOptionValue('side_area_type') === 'side-menu-slide-with-content') {

					$classes[] = 'qodef-' . kudos_qodef_options()->getOptionValue('side_area_slide_with_content_width');

				}

        	}

		}

		return $classes;

    }

    add_filter('body_class', 'kudos_qodef_side_menu_body_class');
}


if(!function_exists('kudos_qodef_get_side_area')) {
	/**
	 * Loads side area HTML
	 */
	function kudos_qodef_get_side_area() {

		if (is_active_widget( false, false, 'qodef_side_area_opener' )) {

			$parameters = array(
				'show_side_area_title' => kudos_qodef_options()->getOptionValue('side_area_title') !== '' ? true : false, //Dont show title if empty
			);

			kudos_qodef_get_module_template_part('templates/sidearea', 'sidearea', '', $parameters);

		}

	}

}

if (!function_exists('kudos_qodef_get_side_area_title')) {
	/**
	 * Loads side area title HTML
	 */
	function kudos_qodef_get_side_area_title() {

		$parameters = array(
			'side_area_title' => kudos_qodef_options()->getOptionValue('side_area_title')
		);

		kudos_qodef_get_module_template_part('templates/parts/title', 'sidearea', '', $parameters);

	}

}

if(!function_exists('kudos_qodef_get_side_menu_icon_html')) {
    /**
     * Function that outputs html for side area icon opener.
     * Uses $kudos_qodef_IconCollections global variable
     * @return string generated html
     */
    function kudos_qodef_get_side_menu_icon_html() {

        $icon_html = '';

		if (kudos_qodef_options()->getOptionValue('side_area_button_icon_pack') !== '') {
			$icon_pack = kudos_qodef_options()->getOptionValue('side_area_button_icon_pack');

			$icons = kudos_qodef_icon_collections()->getIconCollection($icon_pack);
			$icon_options_field = 'side_area_icon_' . $icons->param;

			if (kudos_qodef_options()->getOptionValue($icon_options_field) !== '') {

				$icon = kudos_qodef_options()->getOptionValue($icon_options_field);
				$icon_html = kudos_qodef_icon_collections()->renderIcon($icon, $icon_pack);

			}

		}

        return $icon_html;
    }
}