<?php

/**
 * Force Visual Composer to initialize as "built into the theme". This will hide certain tabs under the Settings->Visual Composer page
 */
if(function_exists('vc_set_as_theme')) {
	vc_set_as_theme(true);
}

/**
 * Change path for overridden templates
 */
if(function_exists('vc_set_shortcodes_templates_dir')) {
	$dir = QODE_ROOT_DIR . '/vc-templates';
	vc_set_shortcodes_templates_dir( $dir );
}

if ( ! function_exists('kudos_qodef_configure_visual_composer') ) {
	/**
	 * Configuration for Visual Composer
	 * Hooks on vc_after_init action
	 */
	function kudos_qodef_configure_visual_composer() {

		/**
		 * Removing shortcodes
		 */
		vc_remove_element("vc_wp_search");
		vc_remove_element("vc_wp_meta");
		vc_remove_element("vc_wp_recentcomments");
		vc_remove_element("vc_wp_calendar");
		vc_remove_element("vc_wp_pages");
		vc_remove_element("vc_wp_tagcloud");
		vc_remove_element("vc_wp_custommenu");
		vc_remove_element("vc_wp_text");
		vc_remove_element("vc_wp_posts");
		vc_remove_element("vc_wp_links");
		vc_remove_element("vc_wp_categories");
		vc_remove_element("vc_wp_archives");
		vc_remove_element("vc_wp_rss");
		vc_remove_element("vc_teaser_grid");
		vc_remove_element("vc_button");
		vc_remove_element("vc_cta_button");
		vc_remove_element("vc_cta_button2");
		vc_remove_element("vc_message");
		vc_remove_element("vc_tour");
		vc_remove_element("vc_progress_bar");
		vc_remove_element("vc_pie");
		vc_remove_element("vc_posts_slider");
		vc_remove_element("vc_toggle");
		vc_remove_element("vc_images_carousel");
		vc_remove_element("vc_posts_grid");
		vc_remove_element("vc_carousel");
		vc_remove_element("vc_gmaps");
		vc_remove_element("vc_btn");
		vc_remove_element("vc_cta");
		vc_remove_element("vc_round_chart");
		vc_remove_element("vc_line_chart");
		vc_remove_element("vc_tta_accordion");
		vc_remove_element("vc_tta_tour");
		vc_remove_element("vc_tta_tabs");
		vc_remove_element("vc_separator");
		vc_remove_element("vc_section");

		/**
		 * Remove unused parameters
		 */
		if (function_exists('vc_remove_param')) {
			vc_remove_param('vc_row', 'full_width');
			vc_remove_param('vc_row', 'full_height');
			vc_remove_param('vc_row', 'content_placement');
			vc_remove_param('vc_row', 'video_bg');
			vc_remove_param('vc_row', 'video_bg_url');
			vc_remove_param('vc_row', 'video_bg_parallax');
			vc_remove_param('vc_row', 'parallax');
			vc_remove_param('vc_row', 'parallax_image');
			vc_remove_param('vc_row', 'gap');
			vc_remove_param('vc_row', 'columns_placement');
			vc_remove_param('vc_row', 'equal_height');
			vc_remove_param('vc_row', 'disable_element');
			vc_remove_param('vc_row', 'parallax_speed_video');
			vc_remove_param('vc_row', 'parallax_speed_bg');
			vc_remove_param('vc_row', 'css_animation');
                        vc_remove_param('vc_text_separator', 'add_icon');
			vc_remove_param('vc_text_separator', 'vc_icon');
			vc_remove_param('vc_text_separator', 'i_icon_material');
			vc_remove_param('vc_text_separator', 'i_icon_monosocial');
			vc_remove_param('vc_text_separator', 'i_type');
			vc_remove_param('vc_text_separator', 'i_icon_fontawesome');
			vc_remove_param('vc_text_separator', 'i_icon_openiconic');
			vc_remove_param('vc_text_separator', 'i_icon_typicons');
			vc_remove_param('vc_text_separator', 'i_icon_entypo');
			vc_remove_param('vc_text_separator', 'i_icon_linecons');
			vc_remove_param('vc_text_separator', 'i_color');
			vc_remove_param('vc_text_separator', 'i_custom_color');
			vc_remove_param('vc_text_separator', 'i_background_color');
			vc_remove_param('vc_text_separator', 'i_background_style');
			vc_remove_param('vc_text_separator', 'i_custom_background_color');
			vc_remove_param('vc_text_separator', 'i_size');
			vc_remove_param('vc_text_separator', 'i_css_animation');

			vc_remove_param('vc_row_inner', 'content_placement');
			vc_remove_param('vc_row_inner', 'equal_height');
			vc_remove_param('vc_row_inner', 'gap');
			vc_remove_param('vc_row_inner', 'disable_element');
		}

	}

	add_action('vc_after_init', 'kudos_qodef_configure_visual_composer');

}


if ( ! function_exists('kudos_qodef_configure_visual_composer_grid_elemets') ) {

	/**
	 * Configuration for Visual Composer for Grid Elements
	 * Hooks on vc_after_init action
	 */

	function kudos_qodef_configure_visual_composer_grid_elemets() {

		/**
		 * Remove Grid Elements if grid elements disabled
		 */
		vc_remove_element('vc_basic_grid');
		vc_remove_element('vc_media_grid');
		vc_remove_element('vc_masonry_grid');
		vc_remove_element('vc_masonry_media_grid');
		vc_remove_element('vc_icon');
		vc_remove_element('vc_button2');
		vc_remove_element("vc_custom_heading");


		/**
		 * Remove unused parameters from grid elements
		 */
		if (function_exists('vc_remove_param')) {
			vc_remove_param('vc_basic_grid', 'button_style');
			vc_remove_param('vc_basic_grid', 'button_color');
			vc_remove_param('vc_basic_grid', 'button_size');
			vc_remove_param('vc_basic_grid', 'filter_color');
			vc_remove_param('vc_basic_grid', 'filter_style');
			vc_remove_param('vc_media_grid', 'button_style');
			vc_remove_param('vc_media_grid', 'button_color');
			vc_remove_param('vc_media_grid', 'button_size');
			vc_remove_param('vc_media_grid', 'filter_color');
			vc_remove_param('vc_media_grid', 'filter_style');
			vc_remove_param('vc_masonry_grid', 'button_style');
			vc_remove_param('vc_masonry_grid', 'button_color');
			vc_remove_param('vc_masonry_grid', 'button_size');
			vc_remove_param('vc_masonry_grid', 'filter_color');
			vc_remove_param('vc_masonry_grid', 'filter_style');
			vc_remove_param('vc_masonry_media_grid', 'button_style');
			vc_remove_param('vc_masonry_media_grid', 'button_color');
			vc_remove_param('vc_masonry_media_grid', 'button_size');
			vc_remove_param('vc_masonry_media_grid', 'filter_color');
			vc_remove_param('vc_masonry_media_grid', 'filter_style');
			vc_remove_param('vc_basic_grid', 'paging_color');
			vc_remove_param('vc_basic_grid', 'arrows_color');
			vc_remove_param('vc_media_grid', 'paging_color');
			vc_remove_param('vc_media_grid', 'arrows_color');
			vc_remove_param('vc_masonry_grid', 'paging_color');
			vc_remove_param('vc_masonry_grid', 'arrows_color');
			vc_remove_param('vc_masonry_media_grid', 'paging_color');
			vc_remove_param('vc_masonry_media_grid', 'arrows_color');
		}
	}
	add_action('vc_after_init', 'kudos_qodef_configure_visual_composer_grid_elemets');
}


if ( ! function_exists('kudos_qodef_configure_visual_composer_frontend_editor') ) {
	/**
	 * Configuration for Visual Composer FrontEnd Editor
	 * Hooks on vc_after_init action
	 */
	function kudos_qodef_configure_visual_composer_frontend_editor() {

		/**
		 * Remove frontend editor
		 */
		if(function_exists('vc_disable_frontend')){
			vc_disable_frontend();
		}

	}
	add_action('vc_after_init', 'kudos_qodef_configure_visual_composer_frontend_editor');
}


if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {
	class WPBakeryShortCode_Qodef_Elements_Holder extends WPBakeryShortCodesContainer {}
	class WPBakeryShortCode_Qodef_Elements_Holder_Item extends WPBakeryShortCodesContainer {}
	class WPBakeryShortCode_Qodef_Tabs extends WPBakeryShortCodesContainer {}
	class WPBakeryShortCode_Qodef_Tab extends WPBakeryShortCodesContainer {}
	class WPBakeryShortCode_Qodef_Accordion extends WPBakeryShortCodesContainer {}
	class WPBakeryShortCode_Qodef_Accordion_Tab extends WPBakeryShortCodesContainer {}
	class WPBakeryShortCode_Qodef_Pricing_Tables extends WPBakeryShortCodesContainer {}
    class WPBakeryShortCode_Qodef_Clients extends WPBakeryShortCodesContainer {}
	class WPBakeryShortCode_Qodef_Item_Showcase extends WPBakeryShortCodesContainer {}
	class WPBakeryShortCode_Qodef_Timeline extends WPBakeryShortCodesContainer {}
	class WPBakeryShortCode_Qodef_Vertical_Split_Slider extends WPBakeryShortCodesContainer {}
	class WPBakeryShortCode_Qodef_Vertical_Split_Slider_Left_Panel extends WPBakeryShortCodesContainer {}
	class WPBakeryShortCode_Qodef_Vertical_Split_Slider_Right_Panel extends WPBakeryShortCodesContainer {}
	class WPBakeryShortCode_Qodef_Vertical_Split_Slider_Item extends WPBakeryShortCodesContainer {}
	class WPBakeryShortCode_Qodef_Advanced_Vertical_Slider extends WPBakeryShortCodesContainer {}
	class WPBakeryShortCode_Qodef_Advanced_Vertical_Slider_Item extends WPBakeryShortCodesContainer {}
	class WPBakeryShortCode_Qodef_Parallax_Sections extends WPBakeryShortCodesContainer {}
	class WPBakeryShortCode_Qodef_Parallax_Section extends WPBakeryShortCodesContainer {}
}

if ( class_exists( 'WPBakeryShortCode' ) ) {
	class WPBakeryShortCode_Qodef_Pricing_Table extends WPBakeryShortCode {}
}

/*** Row ***/
if ( ! function_exists('kudos_qodef_vc_row_map') ) {
	/**
	 * Map VC Row shortcode
	 * Hooks on vc_after_init action
	 */
	function kudos_qodef_vc_row_map()
	{

		$animations = array(
			'No animation' => '',
			'Elements Shows From Left Side' 	=>	'qodef-element-from-left',
			'Elements Shows From Right Side'	=> 	'qodef-element-from-right',
			'Elements Shows From Top Side'		=>	'qodef-element-from-top',
			'Elements Shows From Bottom Side'	=>	'qodef-element-from-bottom',
			'Elements Shows From Fade'			=>	'qodef-element-from-fade'
		);

		vc_add_param('vc_row', array(
			'type' => 'dropdown',
			'class' => '',
			'heading' => esc_html__('Row Type', 'kudos'),
			'param_name' => 'row_type',
			'value' => array(
				esc_html__('Row', 'kudos') => 'row',
				esc_html__('Parallax', 'kudos') => 'parallax'
			)
		));

		vc_add_param('vc_row', array(
			'type' => 'dropdown',
			'class' => '',
			'heading' => esc_html__('Content Width', 'kudos'),
			'param_name' => 'content_width',
			'value' => array(
				esc_html__('Full Width', 'kudos') => 'full-width',
				esc_html__('In Grid', 'kudos') => 'grid'
			)
		));

		vc_add_param('vc_row', array(
			'type' => 'dropdown',
			'class' => '',
			'heading' => esc_html__('Header Style', 'kudos'),
			'param_name' => 'header_style',
			'value' => array(
				esc_html__('Default', 'kudos') => '',
				esc_html__('Light', 'kudos') => 'qodef-light-header',
				esc_html__('Dark', 'kudos') => 'qodef-dark-header'
			),
			'dependency' => Array('element' => 'row_type', 'value' => array('row', 'parallax'))
		));
		vc_add_param('vc_row', array(
			'type' => 'textfield',
			'class' => '',
			'heading' => esc_html__('Anchor ID', 'kudos'),
			'param_name' => 'anchor',
			'value' => '',
			'description' => 'For example "home"'
		));
		vc_add_param('vc_row', array(
			'type' => 'dropdown',
			'class' => '',
			'heading' => esc_html__('Content Aligment', 'kudos'),
			'param_name' => 'content_aligment',
			'value' => array(
				esc_html__('Left', 'kudos') => 'left',
				esc_html__('Center', 'kudos') => 'center',
				esc_html__('Right', 'kudos') => 'right'
			)
		));

		vc_add_param('vc_row', array(
			'type' => 'dropdown',
			'class' => '',
			'heading' => esc_html__('Video Background', 'kudos'),
			'value' => array(
				esc_html__('No', 'kudos') => '',
				esc_html__('Yes', 'kudos') => 'show_video'
			),
			'param_name' => 'video',
			'description' => '',
			'dependency' => Array('element' => 'row_type', 'value' => array('row'))
		));

		vc_add_param('vc_row', array(
			'type' => 'dropdown',
			'class' => '',
			'heading' => esc_html__('Video Overlay', 'kudos'),
			'value' => array(
				esc_html__('No', 'kudos') => '',
				esc_html__('Yes', 'kudos') => 'show_video_overlay'
			),
			'param_name' => 'video_overlay',
			'description' => '',
			'dependency' => Array('element' => 'video', 'value' => array('show_video'))
		));

		vc_add_param('vc_row', array(
			'type' => 'attach_image',
			'class' => '',
			'heading' => esc_html__('Video Overlay Image (pattern)', 'kudos'),
			'value' => '',
			'param_name' => 'video_overlay_image',
			'description' => '',
			'dependency' => Array('element' => 'video_overlay', 'value' => array('show_video_overlay'))
		));

		vc_add_param('vc_row', array(
			'type' => 'textfield',
			'class' => '',
			'heading' => esc_html__('Video Background (webm) File URL', 'kudos'),
			'value' => '',
			'param_name' => 'video_webm',
			'description' => '',
			'dependency' => Array('element' => 'video', 'value' => array('show_video'))
		));

		vc_add_param('vc_row', array(
			'type' => 'textfield',
			'class' => '',
			'heading' => esc_html__('Video Background (mp4) file URL', 'kudos'),
			'value' => '',
			'param_name' => 'video_mp4',
			'description' => '',
			'dependency' => Array('element' => 'video', 'value' => array('show_video'))
		));

		vc_add_param('vc_row', array(
			'type' => 'textfield',
			'class' => '',
			'heading' => esc_html__('Video Background (ogv) file URL', 'kudos'),
			'value' => '',
			'param_name' => 'video_ogv',
			'description' => '',
			'dependency' => Array('element' => 'video', 'value' => array('show_video'))
		));

		vc_add_param('vc_row', array(
			'type' => 'attach_image',
			'class' => '',
			'heading' => esc_html__('Video Preview Image', 'kudos'),
			'value' => '',
			'param_name' => 'video_image',
			'description' => '',
			'dependency' => Array('element' => 'video', 'value' => array('show_video'))
		));

		vc_add_param("vc_row", array(
			'type' => 'dropdown',
			'class' => '',
			'heading' => esc_html__('Full Screen Height', 'kudos'),
			'param_name' => 'full_screen_section_height',
			'value' => array(
				esc_html__('No', 'kudos') => 'no',
				esc_html__('Yes', 'kudos') => 'yes'
			),
			'save_always' => true
		));

		vc_add_param('vc_row', array(
			'type' => 'dropdown',
			'class' => '',
			'heading' => esc_html__('Vertically Align Content In Middle', 'kudos'),
			'param_name' => 'vertically_align_content_in_middle',
			'value' => array(
				esc_html__('No', 'kudos') => 'no',
				esc_html__('Yes', 'kudos') => 'yes'
			),
			'dependency' => array('element' => 'full_screen_section_height', 'value' => 'yes')
		));

        vc_add_param('vc_row', array(
            'type' => 'dropdown',
            'heading' => esc_html__('Arrow Down ', 'kudos'),
            'param_name' => 'arrow_down',
            "value" => array(
                esc_html__('No', 'kudos') => 'no',
                esc_html__('Yes', 'kudos') => 'yes'
            ),
            'description' => ''
        ));

        vc_add_param('vc_row', array(
            'type' => 'textfield',
            'class' => '',
            'heading' => esc_html__('Arrow Down Anchor', 'kudos'),
            'param_name' => 'arrow_down_anchor',
            'value' => '',
            'dependency' => Array('element' => 'arrow_down', 'value' => array('yes'))
        ));

        vc_add_param('vc_row', array(
            'type' => 'colorpicker',
            'heading' => esc_html__('Arrow Down Color', 'kudos'),
            'param_name' => 'arrow_down_color',
            'value' => '',
            'description' => '',
            'dependency' => Array('element' => 'arrow_down',  'value' => array('yes'))
        ));

		vc_add_param('vc_row', array(
			'type' => 'textfield',
			'class' => '',
			'heading' => esc_html__('Section Height', 'kudos'),
			'param_name' => 'section_height',
			'value' => '',
			'dependency' => Array('element' => 'full_screen_section_height', 'value' => array('no'))
		));

		vc_add_param('vc_row', array(
			'type' => 'attach_image',
			'class' => '',
			'heading' => esc_html__('Parallax Background image', 'kudos'),
			'value' => '',
			'param_name' => 'parallax_background_image',
			'description' => 'Please note that for parallax row type, background image from Design Options will not work so you should to fill this field',
			'dependency' => Array('element' => 'row_type', 'value' => array('parallax'))
		));

		vc_add_param('vc_row', array(
			'type' => 'textfield',
			'class' => '',
			'heading' => esc_html__('Parallax speed', 'kudos'),
			'param_name' => 'parallax_speed',
			'value' => '',
			'dependency' => Array('element' => 'row_type', 'value' => array('parallax'))
		));


		vc_add_param('vc_row', array(
			'type' => 'dropdown',
			'heading' => esc_html__('CSS Animation', 'kudos'),
			'param_name' => 'css_animation',
			'value' => $animations,
			'description' => '',
			'dependency' => Array('element' => 'row_type', 'value' => array('row'))
		));

		vc_add_param('vc_row', array(
			'type' => 'textfield',
			'heading' => esc_html__('Transition delay (ms)', 'kudos'),
			'param_name' => 'transition_delay',
			'admin_label' => true,
			'value' => '',
			'description' => '',
			'dependency' => array('element' => 'css_animation', 'not_empty' => true)

		));

        vc_add_param('vc_row', array(
            'type' => 'textfield',
            'heading' => esc_html__('Full width scrolling text in background', 'kudos'),
            'param_name' => 'scrolling_text',
            'value' => '',
            'description' => ''

        ));

        vc_add_param('vc_row', array(
            'type' => 'colorpicker',
            'heading' => esc_html__('Scrolling Text Color', 'kudos'),
            'param_name' => 'scrolling_text_color',
            'group'       => esc_html__('Scrolling Text Style', 'kudos'),
            'value' => '',
            'description' => '',
            'dependency' => Array('element' => 'scrolling_text',  'not_empty' => true)

        ));

        vc_add_param('vc_row', array(
            'type' => 'textfield',
            'heading' => esc_html__('Scrolling Text Font Size', 'kudos'),
            'param_name' => 'scrolling_text_font_size',
            'group'       => esc_html__('Scrolling Text Style', 'kudos'),
            'value' => '',
            'description' => '',
            'dependency' => Array('element' => 'scrolling_text',  'not_empty' => true)

        ));
        vc_add_param('vc_row', array(
            "type" => "textfield",
            "heading" => esc_html__("Scrolling Text Font family", 'kudos'),
            "param_name" => "scrolling_text_font_family",
            'group'       => esc_html__('Scrolling Text Style', 'kudos'),
            "value" => "",
            'dependency' => Array('element' => 'scrolling_text',  'not_empty' => true)
        ));
        vc_add_param('vc_row', array(
            'type' => 'dropdown',
            'heading' => esc_html__('Scrolling Text Font Weight', 'kudos'),
            'param_name' => 'scrolling_text_font_weight',
            'group'       => esc_html__('Scrolling Text Style', 'kudos'),
            'value' => kudos_qodef_get_font_weight_array(true),
            'dependency' => Array('element' => 'scrolling_text',  'not_empty' => true)

        ));
        vc_add_param('vc_row', array(
            'type' => 'textfield',
            'heading' => esc_html__('Scrolling Text Letter Spacing', 'kudos'),
            'param_name' => 'scrolling_text_letter_spacing',
            'group'       => esc_html__('Scrolling Text Style', 'kudos'),
            'value' => '',
            'description' => '',
            'dependency' => Array('element' => 'scrolling_text',  'not_empty' => true)

        ));
        vc_add_param('vc_row', array(
            'type' => 'dropdown',
            'heading' => esc_html__('Scrolling Text Text Transform', 'kudos'),
            'param_name' => 'scrolling_text_text_transform',
            'group'       => esc_html__('Scrolling Text Style', 'kudos'),
            'value' => kudos_qodef_get_text_transform_array(true),
            'dependency' => Array('element' => 'scrolling_text',  'not_empty' => true)

        ));
        vc_add_param('vc_row', array(
            'type' => 'dropdown',
            'heading' => esc_html__('Scrolling Text Font Style', 'kudos'),
            'param_name' => 'scrolling_text_font_style',
            'group'       => esc_html__('Scrolling Text Style', 'kudos'),
            "value" => kudos_qodef_get_font_style_array(true),
            'description' => '',
            'dependency' => Array('element' => 'scrolling_text',  'not_empty' => true)

        ));


		/*** Row Inner ***/

		vc_add_param('vc_row_inner', array(
			'type' => 'dropdown',
			'class' => '',
			'heading' => esc_html__('Row Type', 'kudos'),
			'param_name' => 'row_type',
			'value' => array(
				esc_html__('Row', 'kudos') => 'row',
				esc_html__('Parallax', 'kudos') => 'parallax'
			)
		));

		vc_add_param('vc_row_inner', array(
			'type' => 'dropdown',
			'class' => '',
			'heading' => esc_html__('Content Width', 'kudos'),
			'param_name' => 'content_width',
			'value' => array(
				esc_html__('Full Width', 'kudos') => 'full-width',
				esc_html__('In Grid', 'kudos') => 'grid'
			)
		));

		vc_add_param("vc_row_inner", array(
			'type' => 'dropdown',
			'class' => '',
			'heading' => esc_html__('Full Screen Height', 'kudos'),
			'param_name' => 'full_screen_section_height',
			'value' => array(
				esc_html__('No', 'kudos') => 'no',
				esc_html__('Yes', 'kudos') => 'yes'
			),
			'save_always' => true
		));

		vc_add_param('vc_row_inner', array(
			'type' => 'dropdown',
			'class' => '',
			'heading' => esc_html__('Vertically Align Content In Middle', 'kudos'),
			'param_name' => 'vertically_align_content_in_middle',
			'value' => array(
				esc_html__('No', 'kudos') => 'no',
				esc_html__('Yes', 'kudos') => 'yes'
			),
			'dependency' => array('element' => 'full_screen_section_height', 'value' => 'yes')
		));

		vc_add_param('vc_row_inner', array(
			'type' => 'textfield',
			'class' => '',
			'heading' => esc_html__('Section Height', 'kudos'),
			'param_name' => 'section_height',
			'value' => '',
			'dependency' => Array('element' => 'full_screen_section_height', 'value' => array('no'))
		));

		vc_add_param('vc_row_inner', array(
			'type' => 'attach_image',
			'class' => '',
			'heading' => esc_html__('Parallax Background image', 'kudos'),
			'value' => '',
			'param_name' => 'parallax_background_image',
			'description' => esc_html__('Please note that for parallax row type, background image from Design Options will not work so you should to fill this field', 'kudos'),
			'dependency' => Array('element' => 'row_type', 'value' => array('parallax'))
		));

		vc_add_param('vc_row_inner', array(
			'type' => 'textfield',
			'class' => '',
			'heading' => esc_html__('Parallax speed', 'kudos'),
			'param_name' => 'parallax_speed',
			'value' => '',
			'dependency' => Array('element' => 'row_type', 'value' => array('parallax'))
		));
		vc_add_param('vc_row_inner', array(
			'type' => 'dropdown',
			'class' => '',
			'heading' => esc_html__('Content Aligment', 'kudos'),
			'param_name' => 'content_aligment',
			'value' => array(
				esc_html__('Left', 'kudos') => 'left',
				esc_html__('Center', 'kudos') => 'center',
				esc_html__('Right', 'kudos') => 'right'
			)
		));

		vc_add_param('vc_row_inner', array(
			'type' => 'dropdown',
			'heading' => esc_html__('CSS Animation', 'kudos'),
			'param_name' => 'css_animation',
			'admin_label' => true,
			'value' => $animations,
			'description' => '',
			'dependency' => Array('element' => 'row_type', 'value' => array('row'))

		));

		vc_add_param('vc_row_inner', array(
			'type' => 'textfield',
			'heading' => esc_html__('Transition delay (ms)', 'kudos'),
			'param_name' => 'transition_delay',
			'admin_label' => true,
			'value' => '',
			'description' => '',
			'dependency' => Array('element' => 'row_type', 'value' => array('row'))

		));
	}

	add_action('vc_after_init', 'kudos_qodef_vc_row_map');
}
