<?php 
/*
Template Name: WooCommerce
*/ 
?>
<?php

$kudos_qodef_id = get_option('woocommerce_shop_page_id');
$kudos_qodef_shop = get_post($kudos_qodef_id);
$kudos_qodef_sidebar = kudos_qodef_sidebar_layout();

if(get_post_meta($kudos_qodef_id, 'qode_page_background_color', true) != ''){
	$kudos_qodef_background_color = 'background-color: '.esc_attr(get_post_meta($kudos_qodef_id, 'qode_page_background_color', true));
}else{
	$kudos_qodef_background_color = '';
}

$kudos_qodef_content_style = '';
if(get_post_meta($kudos_qodef_id, 'qode_content-top-padding', true) != '') {
	if(get_post_meta($kudos_qodef_id, 'qode_content-top-padding-mobile', true) == 'yes') {
        $kudos_qodef_content_style = 'padding-top:'.esc_attr(get_post_meta($kudos_qodef_id, 'qode_content-top-padding', true)).'px !important';
	} else {
        $kudos_qodef_content_style = 'padding-top:'.esc_attr(get_post_meta($kudos_qodef_id, 'qode_content-top-padding', true)).'px';
	}
}

if ( get_query_var('paged') ) {
	$kudos_qodef_paged = get_query_var('paged');
} elseif ( get_query_var('page') ) {
	$kudos_qodef_paged = get_query_var('page');
} else {
	$kudos_qodef_paged = 1;
}

get_header();

kudos_qodef_get_title();
do_action('kudos_qodef_before_slider_action');
get_template_part('slider');
do_action('kudos_qodef_after_slider_action');

//Woocommerce content
if ( ! is_singular('product') ) { ?>
	<div class="qodef-container" <?php kudos_qodef_inline_style($kudos_qodef_background_color); ?>>
		<div class="qodef-container-inner clearfix" <?php kudos_qodef_inline_style($kudos_qodef_content_style); ?>>
			<?php
			switch( $kudos_qodef_sidebar ) {
				case 'sidebar-33-right': ?>
					<div class="qodef-two-columns-66-33 qodef-content-has-sidebar qodef-woocommerce-with-sidebar clearfix">
						<div class="qodef-column1">
							<div class="qodef-column-inner">
								<?php kudos_qodef_woocommerce_content(); ?>
							</div>
						</div>
						<div class="qodef-column2">
							<?php get_sidebar();?>
						</div>
					</div>
				<?php
					break;
				case 'sidebar-25-right': ?>
					<div class="qodef-two-columns-75-25 qodef-content-has-sidebar qodef-woocommerce-with-sidebar clearfix">
						<div class="qodef-column1 qodef-content-left-from-sidebar">
							<div class="qodef-column-inner">
								<?php kudos_qodef_woocommerce_content(); ?>
							</div>
						</div>
						<div class="qodef-column2">
							<?php get_sidebar();?>
						</div>
					</div>
				<?php
					break;
				case 'sidebar-33-left': ?>
					<div class="qodef-two-columns-33-66 qodef-content-has-sidebar qodef-woocommerce-with-sidebar clearfix">
						<div class="qodef-column1">
							<?php get_sidebar();?>
						</div>
						<div class="qodef-column2">
							<div class="qodef-column-inner">
								<?php kudos_qodef_woocommerce_content(); ?>
							</div>
						</div>
					</div>
				<?php
					break;
				case 'sidebar-25-left': ?>
					<div class="qodef-two-columns-25-75 qodef-content-has-sidebar qodef-woocommerce-with-sidebar clearfix">
						<div class="qodef-column1">
							<?php get_sidebar();?>
						</div>
						<div class="qodef-column2 qodef-content-right-from-sidebar">
							<div class="qodef-column-inner">
								<?php kudos_qodef_woocommerce_content(); ?>
							</div>
						</div>
					</div>
				<?php
					break;
				default:
					kudos_qodef_woocommerce_content();
			} ?>		
		</div>
	</div>			
<?php } else { ?>
	<div class="qodef-container" <?php kudos_qodef_inline_style($kudos_qodef_background_color); ?>>
		<div class="qodef-container-inner clearfix" <?php kudos_qodef_inline_style($kudos_qodef_content_style); ?>>
			<?php kudos_qodef_woocommerce_content(); ?>
		</div>
	</div>
<?php } ?>
<?php get_footer(); ?>