<?php
namespace KudosQodef\Modules\Shortcodes\Lib;

use KudosQodef\Modules\Shortcodes\Accordion\Accordion;
use KudosQodef\Modules\Shortcodes\AccordionTab\AccordionTab;
use KudosQodef\Modules\Shortcodes\AdvancedVerticalSlider\AdvancedVerticalSlider;
use KudosQodef\Modules\Shortcodes\AdvancedVerticalSliderFixed\AdvancedVerticalSliderFixed;
use KudosQodef\Modules\Shortcodes\AdvancedVerticalSliderFixedItem\AdvancedVerticalSliderFixedItem;
use KudosQodef\Modules\Shortcodes\AdvancedVerticalSliderItem\AdvancedVerticalSliderItem;
use KudosQodef\Modules\Shortcodes\AdvancedVerticalSliderScroll\AdvancedVerticalSliderScroll;
use KudosQodef\Modules\Shortcodes\AdvancedVerticalSliderScrollItem\AdvancedVerticalSliderScrollItem;
use KudosQodef\Modules\Shortcodes\Blockquote\Blockquote;
use KudosQodef\Modules\Shortcodes\BlogList\BlogList;
use KudosQodef\Modules\Shortcodes\BlogSlider\BlogSlider;
use KudosQodef\Modules\Shortcodes\Button\Button;
use KudosQodef\Modules\Shortcodes\CallToAction\CallToAction;
use KudosQodef\Modules\Shortcodes\Clients\Clients;
use KudosQodef\Modules\Shortcodes\Client\Client;
use KudosQodef\Modules\Shortcodes\Counter\Countdown;
use KudosQodef\Modules\Shortcodes\Counter\Counter;
use KudosQodef\Modules\Shortcodes\CustomFont\CustomFont;
use KudosQodef\Modules\Shortcodes\DeviceSlider\DeviceSlider;
use KudosQodef\Modules\Shortcodes\Dropcaps\Dropcaps;
use KudosQodef\Modules\Shortcodes\ElementsHolder\ElementsHolder;
use KudosQodef\Modules\Shortcodes\ElementsHolderItem\ElementsHolderItem;
use KudosQodef\Modules\Shortcodes\GoogleMap\GoogleMap;
use KudosQodef\Modules\Shortcodes\Highlight\Highlight;
use KudosQodef\Modules\Shortcodes\Icon\Icon;
use KudosQodef\Modules\Shortcodes\IconListItem\IconListItem;
use KudosQodef\Modules\Shortcodes\IconWithText\IconWithText;
use KudosQodef\Modules\Shortcodes\InteractiveBanner\InteractiveBanner;
use KudosQodef\Modules\Shortcodes\ImageGallery\ImageGallery;
use KudosQodef\Modules\Shortcodes\Message\Message;
use KudosQodef\Modules\Shortcodes\OrderedList\OrderedList;
use KudosQodef\Modules\Shortcodes\ProductList\ProductList;
use KudosQodef\Modules\Shortcodes\PieCharts\PieChartBasic\PieChartBasic;
use KudosQodef\Modules\Shortcodes\PieCharts\PieChartDoughnut\PieChartDoughnut;
use KudosQodef\Modules\Shortcodes\PieCharts\PieChartDoughnut\PieChartPie;
use KudosQodef\Modules\Shortcodes\PieCharts\PieChartWithIcon\PieChartWithIcon;
use KudosQodef\Modules\Shortcodes\PricingTables\PricingTables;
use KudosQodef\Modules\Shortcodes\PricingTable\PricingTable;
use KudosQodef\Modules\Shortcodes\ProgressBar\ProgressBar;
use KudosQodef\Modules\Shortcodes\Separator\Separator;
use KudosQodef\Modules\Shortcodes\ShopMasonry\ShopMasonry;
use KudosQodef\Modules\Shortcodes\SocialShare\SocialShare;
use KudosQodef\Modules\Shortcodes\Tabs\Tabs;
use KudosQodef\Modules\Shortcodes\Tab\Tab;
use KudosQodef\Modules\Shortcodes\Team\Team;
use KudosQodef\Modules\Shortcodes\UnorderedList\UnorderedList;
use KudosQodef\Modules\Shortcodes\VerticalSplitSlider\VerticalSplitSlider;
use KudosQodef\Modules\Shortcodes\VerticalSplitSliderLeftPanel\VerticalSplitSliderLeftPanel;
use KudosQodef\Modules\Shortcodes\VerticalSplitSliderRightPanel\VerticalSplitSliderRightPanel;
use KudosQodef\Modules\Shortcodes\VerticalSplitSliderItem\VerticalSplitSliderItem;
use KudosQodef\Modules\Shortcodes\VideoButton\VideoButton;
use KudosQodef\Modules\Shortcodes\ItemShowcase\ItemShowcase;
use KudosQodef\Modules\Shortcodes\ItemShowcaseListItem\ItemShowcaseListItem;
use KudosQodef\Modules\Shortcodes\NumberedProcess\NumberedProcess;
use KudosQodef\Modules\Shortcodes\Timeline\Timeline;
use KudosQodef\Modules\Shortcodes\TimelineItem\TimelineItem;
use KudosQodef\Modules\Shortcodes\ImageWithText\ImageWithText;
use KudosQodef\Modules\Shortcodes\ParallaxSections\ParallaxSections;
use KudosQodef\Modules\Shortcodes\ParallaxSection\ParallaxSection;

/**
 * Class ShortcodeLoader
 */
class ShortcodeLoader {
	/**
	 * @var private instance of current class
	 */
	private static $instance;
	/**
	 * @var array
	 */
	private $loadedShortcodes = array();

	/**
	 * Private constuct because of Singletone
	 */
	private function __construct() {}

	/**
	 * Private sleep because of Singletone
	 */
	private function __wakeup() {}

	/**
	 * Private clone because of Singletone
	 */
	private function __clone() {}

	/**
	 * Returns current instance of class
	 * @return ShortcodeLoader
	 */
	public static function getInstance() {
		if(self::$instance == null) {
			return new self;
		}

		return self::$instance;
	}

	/**
	 * Adds new shortcode. Object that it takes must implement ShortcodeInterface
	 * @param ShortcodeInterface $shortcode
	 */
	private function addShortcode(ShortcodeInterface $shortcode) {
		if(!array_key_exists($shortcode->getBase(), $this->loadedShortcodes)) {
			$this->loadedShortcodes[$shortcode->getBase()] = $shortcode;
		}
	}

	/**
	 * Adds all shortcodes.
	 *
	 * @see ShortcodeLoader::addShortcode()
	 */

	private function addShortcodes() {
		$this->addShortcode(new Accordion());
		$this->addShortcode(new AccordionTab());
        $this->addShortcode(new AdvancedVerticalSlider());
        $this->addShortcode(new AdvancedVerticalSliderItem());
		$this->addShortcode(new Blockquote());
		$this->addShortcode(new BlogList());
		$this->addShortcode(new BlogSlider());
		$this->addShortcode(new Button());
		$this->addShortcode(new CallToAction());
        $this->addShortcode(new Clients());
        $this->addShortcode(new Client());
		$this->addShortcode(new Counter());
		$this->addShortcode(new Countdown());
		$this->addShortcode(new CustomFont());
		$this->addShortcode(new DeviceSlider());
		$this->addShortcode(new Dropcaps());
		$this->addShortcode(new ElementsHolder());
		$this->addShortcode(new ElementsHolderItem());
		$this->addShortcode(new GoogleMap());
		$this->addShortcode(new Highlight());
		$this->addShortcode(new Icon());
		$this->addShortcode(new IconListItem());
		$this->addShortcode(new IconWithText());
        $this->addShortcode(new ImageGallery());
        $this->addShortcode(new ImageWithText());
        $this->addShortcode(new InteractiveBanner());
        $this->addShortcode(new ItemShowcase());
        $this->addShortcode(new ItemShowcaseListItem());
		$this->addShortcode(new Message());
		$this->addShortcode(new NumberedProcess());
		$this->addShortcode(new OrderedList());
        $this->addShortcode(new ParallaxSections());
        $this->addShortcode(new ParallaxSection());
        $this->addShortcode(new PieChartBasic());
        $this->addShortcode(new PieChartPie());
        $this->addShortcode(new PieChartDoughnut());
        $this->addShortcode(new PieChartWithIcon());
        $this->addShortcode(new PricingTables());
        $this->addShortcode(new PricingTable());
        $this->addShortcode(new ProductList());
        $this->addShortcode(new ProgressBar());
        $this->addShortcode(new Separator());
		$this->addShortcode(new ShopMasonry());
		$this->addShortcode(new SocialShare());
		$this->addShortcode(new Tabs());
		$this->addShortcode(new Tab());
		$this->addShortcode(new Team());
        $this->addShortcode(new Timeline());
        $this->addShortcode(new TimelineItem());
		$this->addShortcode(new UnorderedList());
		$this->addShortcode(new VerticalSplitSlider());
		$this->addShortcode(new VerticalSplitSliderLeftPanel());
		$this->addShortcode(new VerticalSplitSliderRightPanel());
		$this->addShortcode(new VerticalSplitSliderItem());
		$this->addShortcode(new VideoButton());
	}
	/**
	 * Calls ShortcodeLoader::addShortcodes and than loops through added shortcodes and calls render method
	 * of each shortcode object
	 */
	public function load() {
		$this->addShortcodes();

		foreach ($this->loadedShortcodes as $shortcode) {
			add_shortcode($shortcode->getBase(), array($shortcode, 'render'));
		}
	}
}

$shortcodeLoader = ShortcodeLoader::getInstance();
$shortcodeLoader->load();