<?php

if(!function_exists('kudos_qodef_icon_list_item_map')) {
    function kudos_qodef_icon_list_item_map() {

        $panel = kudos_qodef_add_admin_panel(array(
            'title' => esc_html__('Icon list item', 'select-core'),
            'name'  => 'panel_icon_list_item',
            'page'  => '_elements_page'
        ));

        //Icon options
        kudos_qodef_add_admin_section_title(array(
            'name' => 'icon_section_title',
            'title' => esc_html__('Icon Settings', 'select-core'),
            'parent' => $panel
        ));

        $icon_group = kudos_qodef_add_admin_group(array(
            'name' => 'icon_group',
            'title' => esc_html__('Icon Settings', 'select-core'),
            'description' => esc_html__('Setup icon options', 'select-core'),
            'parent' => $panel
        ));

        $icon_row = kudos_qodef_add_admin_row(array(
            'name' => 'icon_row',
            'next' => true,
            'parent' => $icon_group
        ));

        kudos_qodef_add_admin_field(array(
            'parent'        => $icon_row,
            'type'          => 'colorsimple',
            'name'          => 'icon_list_item_color_setting',
            'default_value' => '',
            'label'         => esc_html__('Icon Color', 'select-core')
        ));

        kudos_qodef_add_admin_field(array(
            'parent'        => $icon_row,
            'type'          => 'textsimple',
            'name'          => 'icon_list_item_font_size_setting',
            'default_value' => '',
            'label'         => esc_html__('Icon Font Size', 'select-core'),
            'args'          => array(
                'suffix' => 'px'
            )
        ));

        //Typography options
        kudos_qodef_add_admin_section_title(array(
            'name' => 'typography_section_title',
            'title' => esc_html__('Icon List Item Typography', 'select-core'),
            'parent' => $panel
        ));

        $typography_group = kudos_qodef_add_admin_group(array(
            'name' => 'typography_group',
            'title' => esc_html__('Icon List Item Typography', 'select-core'),
            'description' => esc_html__('Setup typography for icon list item', 'select-core'),
            'parent' => $panel
        ));

        $typography_row = kudos_qodef_add_admin_row(array(
            'name' => 'typography_row',
            'next' => true,
            'parent' => $typography_group
        ));

        kudos_qodef_add_admin_field(array(
            'parent'        => $typography_row,
            'type'          => 'fontsimple',
            'name'          => 'icon_list_item_font_family',
            'default_value' => '',
            'label'         => esc_html__('Font Family', 'select-core'),
        ));

        kudos_qodef_add_admin_field(array(
            'parent'        => $typography_row,
            'type'          => 'selectsimple',
            'name'          => 'icon_list_item_text_transform',
            'default_value' => '',
            'label'         => esc_html__('Text Transform', 'select-core'),
            'options'       => kudos_qodef_get_text_transform_array()
        ));

        kudos_qodef_add_admin_field(array(
            'parent'        => $typography_row,
            'type'          => 'selectsimple',
            'name'          => 'icon_list_item_font_style',
            'default_value' => '',
            'label'         => esc_html__('Font Style', 'select-core'),
            'options'       => kudos_qodef_get_font_style_array()
        ));

        kudos_qodef_add_admin_field(array(
            'parent'        => $typography_row,
            'type'          => 'textsimple',
            'name'          => 'icon_list_item_letter_spacing',
            'default_value' => '',
            'label'         => esc_html__('Letter Spacing', 'select-core'),
            'args'          => array(
                'suffix' => 'px'
            )
        ));

        $typography_row2 = kudos_qodef_add_admin_row(array(
            'name' => 'typography_row2',
            'next' => true,
            'parent' => $typography_group
        ));

        kudos_qodef_add_admin_field(array(
            'parent'        => $typography_row2,
            'type'          => 'selectsimple',
            'name'          => 'icon_list_item_font_weight',
            'default_value' => '',
            'label'         => esc_html__('Font Weight', 'select-core'),
            'options'       => kudos_qodef_get_font_weight_array()
        ));

        kudos_qodef_add_admin_field(array(
            'parent'        => $typography_row2,
            'type'          => 'textsimple',
            'name'          => 'icon_list_item_font_size',
            'default_value' => '',
            'label'         => esc_html__('Font Size', 'select-core'),
            'args'          => array(
                'suffix' => 'px'
            )
        ));

    }

    add_action('kudos_qodef_options_elements_map', 'kudos_qodef_icon_list_item_map');
}

