<?php
namespace KudosQodef\Modules\Shortcodes\ParallaxSections;

use KudosQodef\Modules\Shortcodes\Lib\ShortcodeInterface;

class ParallaxSections implements ShortcodeInterface{
	private $base;
	function __construct() {
		$this->base = 'qodef_parallax_sections';
		add_action('vc_before_init', array($this, 'vcMap'));
	}
	public function getBase() {
		return $this->base;
	}
	
	public function vcMap() {
		vc_map( array(
			'name' => esc_html__('Select Parallax Section Holder', 'select-core'),
			'base' => $this->base,
			'icon' => 'icon-wpb-parallax-sections extended-custom-icon',
			'category' => esc_html__('by SELECT', 'select-core'),
			'as_parent' => array('only' => 'qodef_parallax_section'),
			'js_view' => 'VcColumnView',
			'params' => array(
				array(
					'type' => 'colorpicker',
					'class' => '',
					'heading' => esc_html__('Background Color', 'select-core'),
					'param_name' => 'background_color',
					'value' => '',
					'description' => ''
				)
			)
		));
	}

	public function render($atts, $content = null) {
	
		$args = array(
			'background_color'  => ''
		);
		$params = shortcode_atts($args, $atts);
		extract($params);

		$html = '';

		$parallax_sections_classes = array();
		$parallax_sections_classes[] = 'qodef-parallax-sections';
		$parallax_sections_style = '';

		if($background_color != ''){
			$parallax_sections_style .= 'background-color:'. $background_color . ';';
		}

		$parallax_sections_class = implode(' ', $parallax_sections_classes);

		$html .= '<div ' . kudos_qodef_get_class_attribute($parallax_sections_class) . ' ' . kudos_qodef_get_inline_attr($parallax_sections_style, 'style'). '>';
			$html .= do_shortcode($content);
		$html .= '</div>';

		return $html;

	}

}
